var winston = require('winston');
var path = require('path');
var fs = require('fs');

module.exports = function(app) {
    var logDir = path.join(__dirname, '../..', '/log/');

    var myCustomLevels = {
        levels: { error: 0, warn: 1, info: 2, verbose: 3, debug: 4, trace: 5 },
        colors: {
            trace: 'blue',
            debug: 'green',
            verbose: 'green',
            info: 'green',
            warn: 'yellow',
            error: 'red'
        }
    };


    //winston.setLevels(myCustomLevels.levels);
    winston.level = 'debug';

    fs.exists(logDir, function(exists) {
        if (!exists) {
            fs.mkdir(logDir);
        }
    });

    winston.loggers.add('default', {
        file: {
            filename: logDir + 'fresenius-m3.log',
            maxFiles: 30, //keep 30 files @ 10mb max
            maxsize: 10000000, //10mb
            tailable: true
        }
    });
    winston.loggers.add('transaction', {
       file: {
           filename: logDir + 'm3-transaction.log',
           maxFiles: 30, //keep 30 files @ 10mb max
           maxsize: 10000000, //10mb
           tailable: true
       }
    });
};