/**
 * Created by John on 3/7/2016.
 */
var fs = require("../../node_modules/node-basic-ods/node_modules/fs-extra");
var async = require("../../node_modules/node-basic-ods/node_modules/async");
var zip = require("../../node_modules/node-basic-ods/node_modules/adm-zip");
var randomstring = require("../../node_modules/node-basic-ods/node_modules/randomstring");
var concat = require("../../node_modules/node-basic-ods/node_modules/concat-files");
var onFinished = require("../../node_modules/node-basic-ods/node_modules/on-finished");

var odsTemplateRowStart = "<table:table-row table:style-name='ro1'>";
var odsTemplateRowEnd = "</table:table-row>";
var odsTemplateCell = function(val){
    return "<table:table-cell office:value-type='string' calcext:value-type='string'><text:p>"+val+"</text:p></table:table-cell>";
}
var odsXML = "";



// TODO :
// - toBufferSync()
// - toFileSync()
// - use key as column header

var convert = function(arr, path){
    for (var r=0; r < arr.length; r++) {
        odsXML += odsTemplateRowStart;
        var item = arr[r];
        for (var key in item) {
            odsXML += odsTemplateCell(item[key]);
        }
        odsXML += odsTemplateRowEnd;

    }

    var workDir = "./components/public/uploads";
    var tmpRoot = workDir + "/tmp/";
    var tmpDir = randomstring.generate(7);
    try {
        fs.mkdirsSync(tmpRoot + tmpDir, 0766);
        fs.mkdirsSync(tmpRoot + tmpDir + "/xml", 0766);
        fs.mkdirsSync(tmpRoot + tmpDir + "/unzipped", 0766);
        fs.copySync(workDir + "/template/xml", tmpRoot + tmpDir + "/xml");
        fs.copySync(tmpRoot + tmpDir + "/xml/contentHeader.xml", tmpRoot + tmpDir + "/unzipped/content.xml");
        fs.appendFileSync(tmpRoot + tmpDir + "/unzipped/content.xml", odsXML);
        fs.appendFileSync(tmpRoot + tmpDir + "/unzipped/content.xml", fs.readFileSync(tmpRoot + tmpDir + "/xml/contentFooter.xml"));
        //concat([
        //    tmpRoot + tmpDir + "/xml/contentHeader.xml",
        //    tmpRoot + tmpDir + "/xml/contentRow.xml",
        //    tmpRoot + tmpDir + "/xml/contentFooter.xml"
        //], tmpRoot + tmpDir + "/unzipped/content.xml", function () {
        fs.emptyDirSync(tmpRoot + tmpDir + "/xml");
        fs.removeSync(tmpRoot + tmpDir + "/xml");
        var zipper = new zip();
        zipper.addLocalFolder(tmpRoot + tmpDir + "/unzipped");
        if (path) {
            zipper.writeZip(path);
        } else {
            var rtn = zipper.toBuffer();
            fs.emptyDirSync(tmpRoot + tmpDir);
            fs.removeSync(tmpRoot + tmpDir);
            return rtn;
        }
        fs.remove(tmpRoot + tmpDir);

       // })
    } catch(err) {
        if (err) console.log(err);
    }

    return null;

}

var deleteFolderRecursive = function(path) {
    if( fs.existsSync(path) ) {
        fs.readdirSync(path).forEach(function(file,index){
            var curPath = path + "/" + file;
            if(fs.lstatSync(curPath).isDirectory()) { // recurse
                deleteFolderRecursive(curPath);
            } else { // delete file
                fs.unlinkSync(curPath);
            }
        });
        fs.rmdirSync(path);
    }
};

var toBuffer = function(arr){
    var rtn = convert(arr, null);
    return rtn;
}
var toFile = function(arr, path){
    return convert(arr, path);
}

module.exports = {
    toBuffer: toBuffer,
    toFile: toFile
}
